function InputTextBox(domId, inputTextValue) {


    var $domElement = $("#" + domId),
        $text = $("<textarea>"),
        placeholderValue = inputTextValue;

//    if (inputTextValue == CAPTIONS.EDIT_NOTE_PALCEHOLDER){
//        if(typeof device != ""){
//            if(device.version < "7"){
//                placeholderValue = "Tap here to add text or tap on the drawing icon to draw";
//            }
//        }
//    }

    $text.unbind("focus").bind("focus", function () {
        $text.attr("placeholder", "");
    });

    $text.unbind("blur").bind("blur", function () {
        $text.attr("placeholder", placeholderValue);
    });

    $text.addClass("textAreaClass");

    $text.attr("placeholder", placeholderValue);

    if (localStorage.getItem($domElement.attr("id")) != null && localStorage.getItem($domElement.attr("id")) != "") {
        $text.attr("value", localStorage.getItem($domElement.attr("id")));
    }

    $text.bind("blur", function () {
        if ($(this).val() != "") {
            localStorage.setItem($domElement.attr("id"), $(this).val());
        }
        else {
            if (localStorage.getItem($domElement.attr("id")) != null) {
                localStorage.removeItem($domElement.attr("id"));
            }
        }
    });

    this.saveText = function () {
        localStorage.setItem($domElement.attr("id"), $text.val());
    };

    this.loadText = function () {
        if (localStorage.getItem($domElement.attr("id")) != null && localStorage.getItem($domElement.attr("id")) != "") {
            $text.attr("value", localStorage.getItem($domElement.attr("id")));
        }
    };

    this.clearInputBox = function () {
        $text.attr("value", "");
    };

    $domElement.html($text);
}
