function SoundOverlayElement() {
            var that = this;

            this.defineClasses = function () {

                that.SoundOverlayView = BaseView.extend({
                    tagName: "div",
                    className: "sceneObject",
                    elementsViews: [],
                    template: templates.getTemplate("image"),
                    id: 'soundOverlay',

                    customInitialize: function () {
                    },

                    events: function () {
                        var _events = {};
                        _events[AppUtils.EventTypes.mouseDown] = "mouseDownHandler";
//                        if (AppUtils.DeviceType.MOBILE_DEVICE) {
//                            _events["touchcancel"] = "touchCancelHandler";
//                        }
                        return _events;
                    },

                    mouseDownHandler: function () {
                       this.$el.css("display", "none");
                    },

                    render: function () {
                        this.$el.html();
//                        this.setWidth(this.model.get("width"));
//                        this.setHeight(this.model.get("height"));
                        this.setWidth(App.settings.width);
                        this.setHeight(App.settings.height);
                        this.$el.css("background-color", "rgba(0,255,255, 0.5)");
                        this.$el.css("z-index", "9999999");
                        return this;
                    }
                });
            };

            this.instantiateObjects = function () {
                that.soundModel = this.getSoundModel();
                that.soundView = new this.SoundOverlayView({
                    model: that.soundModel
                });
            };

            this.getSoundModel = function () {
                that.soundModel = new Backbone.Model({
                    width: App.settings.width,
                    height: App.settings.height,
                    scrollLeft: 0, // keep this for compatibility with alternative impl
                    currentPosition: 0
                });
            };

            return {
                init: function () {
                    that.defineClasses();
                    that.instantiateObjects();
                },
                getView: function () {
                    return that.soundView;
                },
                getModel: function () {
                    return that.soundModel;
                },
                getState: function () {
                    return that.playingState;
                }

            }
}