var MathHelpers = function () {
    return {
        solveCubicEquation: function (y0, y1, y2, y3, value) {

            var a = -y0 + 3 * y1 - 3 * y2 + y3,
                b = 3 * y0 - 6 * y1 + 3 * y2,
                c = -3 * y0 + 3 * y1,
                d = y0 - value;

            //console.log("GYL-414", "Will solve equation: " + a + "x^3+" + b + "x^2+" + c + "x+" + d);

            var f = eval(((3 * c) / a) - (((b * b) / (a * a)))) / 3,
                g = eval((2 * ((b * b * b) / (a * a * a)) - (9 * b * c / (a * a)) + ((27 * (d / a))))) / 27,
                h = eval(((g * g) / 4) + ((f * f * f) / 27)),
                k, m, m2, n, n2, x1, x2, x3, r, rc, theta, x2a, x2b, x2c, sign, dans;

            if (h > 0) {
                m = eval(-(g / 2) + (Math.sqrt(h)));

                k = 1;
                if (m < 0)
                    k = -1;
                else
                    k = 1;
                m2 = eval(Math.pow((m * k), (1 / 3)));
                m2 = m2 * k;
                k = 1;
                n = eval(-(g / 2) - (Math.sqrt(h)));
                if (n < 0)
                    k = -1;
                else
                    k = 1;
                n2 = eval(Math.pow((n * k), (1 / 3)));
                n2 = n2 * k;
                k = 1;

                x1 = eval((m2 + n2) - (b / (3 * a)));
                x2 = (-1 * (m2 + n2) / 2 - (b / (3 * a)) + " + i* " + ((m2 - n2) / 2) * Math.pow(3, .5));
                x3 = (-1 * (m2 + n2) / 2 - (b / (3 * a)) + " - i* " + ((m2 - n2) / 2) * Math.pow(3, .5));
            }

            if (h <= 0) {
                r = (eval(Math.sqrt((g * g / 4) - h)));
                k = 1;
                if (r < 0) k = -1;
                rc = Math.pow((r * k), (1 / 3)) * k;
                //k = 1;
                theta = Math.acos((-g / (2 * r)));
                x1 = eval(2 * (rc * Math.cos(theta / 3)) - (b / (3 * a)));
                x2a = rc * -1;
                x2b = Math.cos(theta / 3);
                x2c = Math.sqrt(3) * (Math.sin(theta / 3));
                //x2d = (b / 3 * a) * -1;
                x2 = eval(x2a * (x2b + x2c)) - (b / (3 * a));
                x3 = eval(x2a * (x2b - x2c)) - (b / (3 * a));

                x1 = x1 * 1E+14;
                x1 = Math.round(x1);
                x1 = (x1 / 1E+14);
                x2 = x2 * 1E+14;
                x2 = Math.round(x2);
                x2 = (x2 / 1E+14);
                x3 = x3 * 1E+14;
                x3 = Math.round(x3);
                x3 = (x3 / 1E+14);

            }


            if ((f + g + h) == 0) {
                if (d < 0) {
                    sign = -1;
                }
                if (d >= 0) {
                    sign = 1;
                }
                if (sign > 0) {
                    dans = Math.pow((d / a), (1 / 3));
                    dans = dans * -1;
                }
                if (sign < 0) {
                    d = d * -1;
                    dans = Math.pow((d / a), (1 / 3));
                }
                x1 = dans;
                x2 = dans;
                x3 = dans;
            }

            var solution = 0;
            if (typeof x1 == "number" && x1 >= 0) {
                solution = x1;
            }
            if (typeof x2 == "number" && x2 >= 0 && x2 < solution) {
                solution = x2;
            }
            if (typeof x1 == "number" && x1 >= 0 && x3 < solution) {
                solution = x3;
            }

            console.log("GYL-414", "Solution: " + solution);

            console.log("GYL-414", "x1: " + x1, typeof x1);
            console.log("GYL-414", "x2: " + x2, typeof x2);
            console.log("GYL-414", "x3: " + x3, typeof x3);

            return solution;
        }
    };
};

var mathHelpers = new MathHelpers;
