var UserDialogs = (function () {

//    var id= 0;

    return {
        showAlert: function (message, title, buttonName) {
            if (AppUtils.nativeApp) {
                navigator.notification.alert(
                    message,
                    null, //callback
                    title,
                    buttonName
                );
            } else if (AppUtils.DeviceType.W8) {
                var md = new Windows.UI.Popups.MessageDialog(message);
                md.showAsync();
            } else {
                alert(message);
            }
        },

        showConfirmation: function (message, title, buttonLabels, callback) {
            if (AppUtils.nativeApp) {
                navigator.notification.confirm(message, callback, title, buttonLabels);
            }
            else {
                callback(confirm(message));
            }
        }
    };
})();