var CSSConstants = {
    /**
     * @return {number}
     */
    ActiveTabViewHeight: function () {
        return Math.round(50 * AppUtils.getMenuScaleFactor());
    },
    /**
     * @return {number}
     */
    ActiveTabViewWidth: function () {
        var customWidth = AppUtils.runCustomMenuMethod("getActiveTabCustomWidth");
        customWidth = (customWidth != null) ? customWidth : 86;
        return Math.round(customWidth * AppUtils.getMenuScaleFactor());
    },
    /**
     * @return {number}
     */
    CustomActiveTabViewWidth: function (originalWidth) {
        return Math.round(originalWidth * AppUtils.getMenuScaleFactor());
    },
    /**
     * @return {number}
     */
    ActiveTabViewImageHeight: function () {
        return Math.round(31 * AppUtils.getMenuScaleFactor());
    },
    /**
     * @return {number}
     */
    DefaultActiveTabWrapperHeight: function () {
        return Math.round(51 * AppUtils.getMenuScaleFactor());
    },
    /**
     * @return {number}
     */
    OffsetForHiddenTabs: function () {
        return Chapter.getSettings()['useDirectTOCBottomMenu'] ? Math.round(51 * AppUtils.getMenuScaleFactor()) : 0;
    },

    /**
     * @return {number}
     */
    MenuSettingsFontSize: function () {
        return Math.round(16 * AppUtils.getMenuScaleFactor());
    },

    /**
     * @return {number}
     */
    MenuTocArrowWidth: function () {
        return Math.round(55 * AppUtils.getMenuScaleFactor());
    }
};