var projectNotesTemplates = {
        getTemplate: function (type) {
//        console.log("Template of type " + type);
            if (null == this[type]) {
                this[type] = _.template(projectNotesHTMLTemplates.getTemplate(type));
            }
            return this[type];
        }
    },
    projectNotesHTMLTemplates = {
        getTemplate: function (type) {
            return this[type]();
        },

        image: function () {
            return [
                "<img class='images'",
                "src='<%- imageURL %>'",
                "width='100%'",
                "height='100%'>"
            ].join("\n");
        },

        drawingElementCanvas: function () {
            return   [
                "<canvas id='<%- canvasId %>'></canvas>"
            ].join("\n");
        },

        backBtnImage: function () {
            return [
                "<div class='ButtonImages backBtnViewBackground'></div> "
            ].join("\n");
        },

        drawingBtnImage: function () {
            return [
                "<div class='ButtonImages drawingBtnViewBackground'></div> "
            ].join("\n");
        },

        textBtnImage: function () {
            return [
                "<div class='ButtonImages textBtnViewBackground'></div> "
            ].join("\n");
        },

        clearBtnImage: function () {
            return [
                "<div class='ButtonImages clearBtnViewBackground'></div> "
            ].join("\n");
        },

        deleteBtnImage: function () {
            return [
                "<div class='ButtonImages deleteBtnViewBackground'></div> "
            ].join("\n");
        },

        textElementView: function () {
            return   [
                "<textarea class='textAreaClass'></textarea>"
            ].join("\n");
        },

        drawingElementView: function () {
            return   [
                "<canvas id='notesDrawingView_canvas' class='canvasInitialState' width='100%' height='100%'></canvas>"
            ].join("\n");
        },

        newNoteBtnImage: function () {
            return [
                "<div class='ButtonImages newNoteBtnViewBackground'></div> "
            ].join("\n");
        },

        closeListViewBtnViewImage: function () {
            return [
                "<div class='ButtonImages closeListNoteBtnViewBackground'></div> "
            ].join("\n");
        },

        closePrimaryViewBtnImage: function () {
            return [
                "<div class='ButtonImages closePrimaryNoteBtnViewBackground'></div> "
            ].join("\n");
        },

        itemTitleView: function () {
            return   [
                "<%- itemTitle %>"
            ].join("\n");
        }
    };

