if (!window["ModelAccessFunctions"]) window["ModelAccessFunctions"] = {};

(function (ModelAccessFunctions) {

    ModelAccessFunctions.shouldNotHideBecauseOfEffects = function (model) {
        return model.get("displayHideOnClick") ||
            model.get("displayHideOnceOnClick") ||
            model.get("onePulseOnClick") ||
            model.get("onePulseOnceOnClick") ||
            model.get("multiplePulsesOnClick") ||
            model.get("multiplePulsesOnceOnClick") ||
            model.get("fadeInOutOnClick") ||
            model.get("fadeInOutOnceOnClick");
    };

})(window["ModelAccessFunctions"]);