PersistentSceneObjectsUtils = {
    persistentObjects: [],
    addNewPersistentObject: function (object) {
        if (object.getModel().get('availableInAllOrientations')) {
            this.persistentObjects.push(object);
        }
    },
    getPersistentObject: function (id) {
        var idx;
        for (idx = 0; idx < this.persistentObjects.length; idx++) {
            if (this.persistentObjects[idx].getModel().get('id') == id)
                return this.persistentObjects[idx];
        }
        return null;
    },
    removePersistentObject: function (id) {
        var idx;
        for (idx = 0; idx < this.persistentObjects.length; idx++) {
            if (this.persistentObjects[idx].getModel().get('id') == id)
                this.persistentObjects.splice(idx, 1);
        }
    },
    anotherPersistentSoundIsPlaying: function (id) {
        var idx, object;
        for (idx = 0; idx < this.persistentObjects.length; idx++) {
            object = this.persistentObjects[idx];
            if (object.getModel().get('type') == 'sound') {
                if (object.getState() == SoundState.PLAYING && object.getView().parentElementModel.get('index') == Chapter.getActivePage())
                    return true;
            }
        }
        return false;
    }
};