/**
 * Created by ionutmovila on 26/11/14.
 */

function VideoPlayerHelpers() {

    return {
        stopAllPlayingVideosForPage: function (pageModel) {
            var objectInPage, idx;
            console.log("Now stop all videos for old page");
            for (idx = 0; idx < pageModel.get("workingObjectsCollection").length; idx++) {
                objectInPage = pageModel.get("workingObjectsCollection").models[idx];
                if (objectInPage.get("type") == "video") {
                    console.log("Now should stop video " + objectInPage.get("id"));
                    if (!objectInPage.get("isIconVideo")) { // no need to stop videos that are played in lightbox
                        objectInPage.set("videoState", VideoState.STOP);
                    }
                }
            }
        }
    }
}

var VideoPlayer = new VideoPlayerHelpers();
